<!DOCTYPE html>
<html lang="en">
<title>POI Hours of Operation</title>
<meta charset="UTF-8">
<meta name="viewport" content="width=device-width, initial-scale=1">
<link rel="stylesheet" href="https://www.w3schools.com/w3css/4/w3.css">
<link rel="stylesheet" href="https://www.w3schools.com/lib/w3-theme-black.css">
<link href="https://fonts.googleapis.com/css?family=Crimson+Text|Open+Sans" rel="stylesheet">
<!--<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">-->
<link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.8.2/css/all.css" integrity="sha384-oS3vJWv+0UjzBfQzYUhtDYW+Pj2yciDJxpsK1OYPAYjqT085Qq/1cq5FLXAZQ7Ay" crossorigin="anonymous">
<link rel="stylesheet" href="https://unpkg.com/leaflet@1.4.0/dist/leaflet.css"
   integrity="sha512-puBpdR0798OZvTTbP4A8Ix/l+A4dHDD0DGqYW6RQ+9jxkRFclaxxQb/SJAWZfWAkuyeQUytO7+7N4QKrDh+drA=="
   crossorigin=""/>
<script src="https://unpkg.com/leaflet@1.4.0/dist/leaflet.js"
   integrity="sha512-QVftwZFqvtRNi0ZyCtsznlKSWOStnDORoefr1enyq5mVL4tmKB3S/EnC3rRJcxCPavG10IcrVGSmPh6Qw5lwrg=="
   crossorigin=""></script>
<script type="text/javascript" src="https://d3js.org/d3.v3.min.js"></script>
<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/leaflet-easybutton@2/src/easy-button.css">
<script src="https://cdn.jsdelivr.net/npm/leaflet-easybutton@2/src/easy-button.js"></script>
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.4.0/jquery.min.js"></script>
<script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.4.0/js/bootstrap.min.js"></script>
<style>
html,body,h1,h2,h3,h4,h5,h6 {font-family: 'Crimson Text', serif;}
/*html{height: 100%;}*/
/*body { height: 100%; position: absolute; }*/
p {font-family: 'Open Sans', sans-serif; font-size: 90%;}
span {font-family: 'Open Sans', sans-serif; font-size: 90%;}
.w3-sidebar {
  z-index: 3;
  width: 100px;
  top: 43px;
  bottom: 0;
  height: inherit;
}

a:hover {
  color: #0000FF;
}
a{
  text-decoration:none;
  color:#10147E;
}

/*.container-fluid {*/
/*  height: 100vh;*/
/*}*/

/*#body {*/
/*width: 100%;*/
/*height: 100%;*/
/*}*/

/*.body {*/
/*width: 100%;*/
/*height: 100%;*/
/*}*/

/*test*/

.content{
    height: 100vh;
    /*overflow: hidden;*/
}

/*#content{*/
/*    height: 100vh;*/
/*    overflow: hidden;*/
/*}*/


.square {
  float: right;
  width: 20px;
  height: 20px;
  margin-left: 5px;
  border: 1px solid rgba(0, 0, 0, .2);
}

.pink {
  background: #e9a3c9;
}

.green {
  background: #a1d76a;
}

.axis path,
.axis line {
  fill: none;
  stroke: #000;
  shape-rendering: crispEdges;
}

.axis { font: 14px 'Open Sans'; }

.x.axis path {
  display: none;
}

.hidden {
  display: none;
  visibility: none;
}

.line {
  fill: none;
  stroke: steelblue;
  stroke-width: 1.5px;
}

/* The switch - the box around the slider */
.switch {
  position: relative;
  display: inline-block;
  width: 35px;
  height: 20px;
}

/* Hide default HTML checkbox */
.switch input {
  opacity: 0;
  width: 0;
  height: 0;
}

/* The slider */
.slider {
  position: absolute;
  cursor: pointer;
  top: 0;
  left: 0;
  right: 0;
  bottom: 0;
  background-color: #D3D3D3;
  -webkit-transition: .4s;
  transition: .4s;
}

.slider:before {
  position: absolute;
  content: "";
  height: 13px;
  width: 13px;
  left: 4px;
  bottom: 4px;
  background-color: white;
  -webkit-transition: .4s;
  transition: .4s;
}

input:checked + .slider {
  background-color: #37bc12;
}

input:focus + .slider {
  box-shadow: 0 0 1px #2196F3;
}

input:checked + .slider:before {
  -webkit-transform: translateX(14px);
  -ms-transform: translateX(14px);
  transform: translateX(14px);
}

/* Rounded sliders */
.slider.round {
  border-radius: 34px;
}

.slider.round:before {
  border-radius: 50%;
}

</style>

<body>

 <!--Navbar -->
<!--<div class="w3-top">-->
<!--  <div class="w3-bar w3-theme w3-top w3-left-align w3-large">-->
<!--    <a class="w3-bar-item w3-button w3-right w3-hide-large w3-hover-white w3-large w3-theme-l1" href="javascript:void(0)" onclick="w3_open()"><i class="fa fa-bars"></i></a>-->
<!--    <a href="#" class="w3-bar-item w3-button w3-theme-l1">PlanetSense POI Business Temporal Patterns</a>-->
<!--    <a href="#" class="w3-bar-item w3-button w3-hide-small w3-hover-white">Tab 2</a>-->
<!--    <a href="#" class="w3-bar-item w3-button w3-hide-small w3-hover-white">Tab 3</a>-->
<!--  </div>-->
<!--</div>-->

<!-- Sidebar -->
<!--<nav class="w3-sidebar w3-bar-block w3-collapse w3-large w3-theme-l5 w3-animate-left" id="mySidebar">-->
<!--  <a href="javascript:void(0)" onclick="w3_close()" class="w3-right w3-xlarge w3-padding-large w3-hover-black w3-hide-large" title="Close Menu">-->
<!--    <i class="fa fa-remove"></i>-->
<!--  </a>-->
<!--  <h4 class="w3-bar-item"><b>Menu</b></h4>-->
<!--  <a class="w3-bar-item w3-button w3-hover-black" href="#">Link</a>-->
<!--  <a class="w3-bar-item w3-button w3-hover-black" href="#">Link</a>-->
<!--  <a class="w3-bar-item w3-button w3-hover-black" href="#">Link</a>-->
<!--  <a class="w3-bar-item w3-button w3-hover-black" href="#">Link</a>-->
<!--</nav>-->

    <!-- Overlay effect when opening sidebar on small screens -->
    <!--<div class="w3-overlay w3-hide-large" onclick="w3_close()" style="cursor:pointer" title="close side menu" id="myOverlay"></div>-->

    <!-- Main content: shift it to the right by 250 pixels when the sidebar is visible -->
    <div id="content" class="content">
        <div class="w3-row" style="padding-left: 24px; padding-right: 24px; padding-top: 0px; padding-bottom:10px;">
            <div class="w3-twothird w3-container" style="width:60%;">
              <h1 class="w3-text-dark-grey" style="margin: 0; padding: 0;">When Do Cities Operate?</h1>
              <p class="w3-text-dark-grey" style="font-size: 82%; margin: 0; padding: 0;">Cities continue to grow as major centers of population, economic development, and innovation, and are often seen as both the cause and solution for many global environmental and economic problems. As such, understanding how cities function will be critical for achieving long-term global environmental and economic sustainability. Temporal patterns of cities are a vital component of how cities operate. The amount of time (and periods of time) allotted for business transactions and social interactions to take place is connected with the economic and social output of the city.</p>
            </div>
            <div class="w3-third w3-container" style="width:25%;">
              <h1 class="w3-text-dark-grey" style="margin: 0; padding: 0;">Clustering Cities</h1>
              <p class="w3-text-dark-grey" style="margin: 0; padding: 0;">Cluster cities based off their restaurant, retail, or general temporal patterns. Cities that are clustered together share similar temporal patterns throughout the week.</p>
            </div>
            <div class="w3-third w3-container" style="width:15%; padding-top: 52px;">
              <div>
                <label class="switch">
                  <input type="checkbox" id="generalCheckbox" onchange="toggleClustering(this)" checked>
                  <span class="slider round"></span>
                </label><span> None</span><br>
                <label class="switch">
                  <input type="checkbox" id="restaurantCheckbox" onchange="toggleClustering(this)">
                  <span class="slider round"></span>
                </label><span> Restaurant</span><br>
                <label class="switch">
                  <input type="checkbox" id="retailCheckbox" onchange="toggleClustering(this)">
                  <span class="slider round"></span>
                </label><span> Retail</span>
              </div>
            </div>
        </div>
        <div class="w3-row" style="padding-left: 24px; padding-right: 24px; padding-bottom: 0px;">
            <div class="w3-half w3-container" style="width:60%;">
              <div id="mapid" style="height: 500px;"></div>
                <h3 class="w3-text-dark-grey" style="margin: 0; padding-top: 12px;">Data</h3>
                <p class="w3-text-dark-grey" style="margin: 0; padding: 0;"><b>What:</b> Public Facebook Points of Interest (business pages) hours of operation</p>
                <p class="w3-text-dark-grey" style="margin: 0; padding: 0;"><b>When:</b> July 2016 - March 2017</p>
            </div>
            <div class="w3-half w3-container" style="width:40%;">
              <div id="selectionText" style="display: none;"><center><p><font color="red">Only two cities are supported at a time. Please deselect a city if you would like to select a new one.</font></p></center></div>
            </div>
            <div class="w3-half w3-container" style="width:40%; padding-left: 2%; padding-right: 2%; padding-top:0px; padding-bottom:0px;">
                <p style="text-align:left; margin:0; padding: 0;" class="w3-text-dark-grey">
                X-Axis: Time
                <span id="legend1Square" class="square pink" style="visibility:hidden;"></span>
                <span id="legend1Text" style="float:right; visibility:hidden;">Test 1</span>
                </p>
                
                <p style="text-align:left; margin:0; padding: 0;" class="w3-text-dark-grey">
                Y-Axis: Number of Businesses Open
                <span id="legend2Square" class="square green" style="visibility:hidden;"></span>
                <span id="legend2Text" style="float:right; visibility:hidden;">Test 2</span>
                </p>
            </div>
            <div class="w3-half w3-container" id="generalDiv" style="width:40%;">
              <div id="chart1" style="max-width: 100%; max-height: 100%;"></div>
            </div>
            <div class="w3-half w3-container" id="restaurantDiv" style="width:40%;">
              <div id="chart2" style="max-width: 100%; max-height: 100%;"></div>
            </div>
            <div class="w3-half w3-container" id="retailDiv" style="width:40%;">
              <div id="chart3" style="max-width: 100%; max-height: 100%;"></div>
            </div>
        </div>
        <div class="w3-row" style="padding-left: 24px; padding-right: 24px; padding-bottom: 12px; padding-top:12px;">
            <div class="w3-half w3-container" style="width:60%;">
                <h3 class="w3-text-dark-grey" style="margin: 0; padding: 0;">Scientific References</h3>
                <p class="w3-text-dark-grey" style="margin: 0; padding: 0;">Sparks, K., Thakur, G., Pasarkar, A. and Urban, M., 2019. A Global Analysis of Cities’ Geosocial Temporal Signatures for Points of Interest Hours of Operation. <i>International Journal of Geographical Information Science. </i><a href="https://www.tandfonline.com/doi/full/10.1080/13658816.2019.1615069" target="_blank">[Link]</a></p>
            </div>
            <div class="w3-half w3-container" style="width:40%;">
                <h3 class="w3-text-dark-grey" style="margin: 0; padding: 0;">People</h3>
                <p class="w3-text-dark-grey" style="margin: 0; padding: 0;"><b>Kevin Sparks</b> | <i>Research</i></p>
                <p class="w3-text-dark-grey" style="margin: 0; padding: 0;"><b>Gautam Thakur</b> | <i>Data Collection</i></p>
                <p class="w3-text-dark-grey" style="margin: 0; padding: 0;"><b>Jordan Burdette</b> | <i>Visualization Development</i></p>
            </div>
        </div>
    </div>
    
<!-- END MAIN -->


<script>
var pointColors = {"retailCheckbox": ["#e7298a","#7570b3","#d95f02","#1b9e77"], "restaurantCheckbox": ["#7570b3","#1b9e77","#d95f02"]};
//setting general as the default
var checked = "generalCheckbox";
var numberMap = {"retailCheckbox": 3, "restaurantCheckbox": 4}

function toggleClustering(checkbox) {
    checked = checkbox.id;
    if (checkbox.checked) {
        if(checkbox.id == "generalCheckbox"){
            document.getElementById("restaurantCheckbox").checked = false;
            document.getElementById("retailCheckbox").checked = false;
            setPointColors();
        }
        if(checkbox.id == "restaurantCheckbox"){
            document.getElementById("generalCheckbox").checked = false;
            document.getElementById("retailCheckbox").checked = false;
            setPointColors();
        }
        if(checkbox.id == "retailCheckbox"){
            document.getElementById("generalCheckbox").checked = false;
            document.getElementById("restaurantCheckbox").checked = false;
            setPointColors();
        }
  } 
  else {
      //not allowing unchecking
      document.getElementById(checkbox.id).checked = true;
  }
}


function setPointColors(){
    group1.clearLayers();
    for (var i = 0; i < locations.length; i++) {
        var pointRadius = 3;
        var name = "#" + locations[i][0].replace(/ /g,'');
        if(checked == "generalCheckbox"){
            var pointColor = '#3a3a3a';
        }
        else{
            var pointColor = pointColors[checked][locations[i][numberMap[checked]]-1];
        }
        var borderColor = pointColor;
        for (var j = 0; j < selectedList.length; j++) {
            if(selectedList[j][0] == name){
                // console.log(name + " was selected");
                pointRadius = 10;
                // if(checked == "generalCheckbox"){
                //      borderColor = '#C0C0C0'
                // }
                // else{
                    borderColor = '#F8C520'
                // }
            }
        }
        circle = new L.circleMarker([locations[i][1],locations[i][2]], {
            radius: pointRadius,
            color: borderColor,
            fillColor: pointColor,
            fillOpacity: 1.0,
            title: locations[i][0]
    })
    .bindPopup(locations[i][0])
    .on('mouseover', function (e) {this.openPopup();})
    .on('mouseout', function (e) {this.closePopup();})
    .on('click', function(e) {
        toggleSelect(e.sourceTarget.options.title, this);
    })
    .addTo(group1);
    }
    group1.addTo(mymap);
}


function toggleSelect(name, circle) {
    var fillColor = circle.options.fillColor;
    var originalName = name;
    var name = "#" + name.replace(/ /g,'');
    remove = false;
    for (var i = 0; i < selectedList.length; i++) {
        if(selectedList[i][0] == name){
            //unselecting circle
            remove = true;
            selectedList.splice(i, 1);
            d3.select(name + "GeneralLine").style("opacity", 0);
            d3.select(name + "RestaurantLine").style("opacity", 0);
            d3.select(name + "RetailLine").style("opacity", 0);
            circle.setStyle({color:fillColor});
            circle.setRadius(3);
            selectedCount = selectedCount - 1;
            var selectionText = document.getElementById("selectionText");
            selectionText.style.display = "none";
            //if 2nd line was pink and removed, set first one to pink
            if(selectedCount == 1){
                d3.select(selectedList[0][0] + "GeneralLine").style("stroke", '#e9a3c9');
                d3.select(selectedList[0][0] + "RestaurantLine").style("stroke", '#e9a3c9');
                d3.select(selectedList[0][0] + "RetailLine").style("stroke", '#e9a3c9');
                document.getElementById("legend2Text").style.visibility = "hidden";
                document.getElementById("legend2Square").style.visibility = "hidden";
                document.getElementById("legend1Text").innerHTML = selectedList[0][1];
            }
            if(selectedCount == 0){
                document.getElementById("legend1Text").style.visibility = "hidden";
                document.getElementById("legend1Square").style.visibility = "hidden";
            }
        }
    }
    if(selectedCount >= 2 && remove == false){
        var selectionText = document.getElementById("selectionText");
        selectionText.style.display = "block";
    }
    if(selectedCount < 2 && remove == false){
        if(circle.options.color == 'black'){
            circle.setStyle({color:'#3a3a3a'})
            circle.setRadius(3);
        }
        else{
            // if(checked == "generalCheckbox"){
            //     circle.setStyle({color:'#C0C0C0'})
            // }
            // else{
                circle.setStyle({color:'#F8C520'})
            // }
            circle.setRadius(10);
        }
        
        selectedList.push([name, originalName]);
        var line = d3.select(name + "GeneralLine");
        var text = d3.select(name + "GeneralText");
        if(line[0][0].style.opacity == 1){
            d3.select(name + "GeneralLine").style("opacity", 0);
            d3.select(name + "RestaurantLine").style("opacity", 0);
            d3.select(name + "RetailLine").style("opacity", 0);
        }
        else{
            var stroke = '#e9a3c9';
            var line = d3.select(name + "GeneralLine");
            if(selectedCount == 0){
                document.getElementById("legend1Text").style.visibility = "visible";
                document.getElementById("legend1Square").style.visibility = "visible";
                document.getElementById("legend1Text").innerHTML = originalName;
            }
            if(selectedCount == 1){
                document.getElementById("legend2Text").innerHTML = originalName;
                document.getElementById("legend2Text").style.visibility = "visible";
                document.getElementById("legend2Square").style.visibility = "visible";
                stroke = '#a1d76a';
            }
            d3.select(name + "GeneralLine").style("opacity", 1).style("stroke", stroke);
            d3.select(name + "RestaurantLine").style("opacity", 1).style("stroke", stroke);
            d3.select(name + "RetailLine").style("opacity", 1).style("stroke", stroke);
        }
        selectedCount = selectedCount + 1;
    }
}

//Initializing Leaflet stuff
var mymap = L.map('mapid').setView([0, 0], 2);

var corner1 = L.latLng(180, 180);
var corner2 = L.latLng(-180, -180);
var bounds = L.latLngBounds(corner1, corner2);

L.tileLayer('https://api.tiles.mapbox.com/v4/{id}/{z}/{x}/{y}.png?access_token={accessToken}', {
    attribution: 'Map data &copy; <a href="https://www.openstreetmap.org/">OpenStreetMap</a> contributors, <a href="https://creativecommons.org/licenses/by-sa/2.0/">CC-BY-SA</a>, Imagery © <a href="https://www.mapbox.com/">Mapbox</a>',
    maxZoom: 18,
    bounds: bounds,
    noWrap: true,
    id: 'mapbox.light',
    accessToken: 'pk.eyJ1IjoiYnVyZGV0dGVqYSIsImEiOiJjanNkbjBlc2gwNzQ5M3lwajdsY3hlMzEwIn0.sAmBE0s2qUBJ4ihiwla1ug'
}).addTo(mymap);

//home button
L.easyButton('fa-times-circle fa-lg',function(btn,map){
    map.setView([0, 0], 2);
    clearSelections();
    setPointColors();
},'Clear Selections').addTo(mymap);

function clearSelections(){
    for (var i = 0; i < selectedList.length; i++) {
        //clearing selections for charts and legend
        // selectedList.splice(i, 1);
        d3.select(selectedList[i][0] + "GeneralLine").style("opacity", 0);
        d3.select(selectedList[i][0] + "RestaurantLine").style("opacity", 0);
        d3.select(selectedList[i][0] + "RetailLine").style("opacity", 0);
        document.getElementById("legend1Text").style.visibility = "hidden";
        document.getElementById("legend1Square").style.visibility = "hidden";
        document.getElementById("legend2Text").style.visibility = "hidden";
        document.getElementById("legend2Square").style.visibility = "hidden";
        selectedCount = selectedCount - 1;
        var selectionText = document.getElementById("selectionText");
        selectionText.style.display = "none";
    }
    selectedCount = 0;
    selectedList = [];
    remove = false;
}

function setDefaultSelection(){
    toggleSelect(randomCity.options.title, randomCity);
}

//format: city, lat, long, retail, restaurant
// var locations = [
//   ["Algiers",36.753768,3.0587561,2,1  ],
//   ["Almaty",43.2220146,76.8512485,2,1  ],
//   ["Amman",31.9453666,35.9283716,2,1  ],
//   ["Amsterdam",52.3702157,4.8951679,3,1  ],
//   ["Ankara",39.9333635,32.8597419,2,1  ],
//   ["Astana",51.1605227,71.4703558,2,1  ],
//   ["Asuncion",-25.2637399,-57.575926,2,1  ],
//   ["Athens",37.9838096,23.7275388,3,2  ],
//   ["Auckland",-36.8484597,174.7633315,3,1  ],
//   ["Baghdad",33.3128057,44.3614875,1,1  ],
//   ["Baku",40.40718,49.866886,2,1  ],
//   ["Bamako",12.6392316,-8.0028892,2,1  ],
//   ["Bangkok",13.75423,100.499294,2,1  ],
//   ["Barcelona",41.3850639,2.1734035,4,1  ],
//   ["Beirut",33.8937913,35.5017767,2,1  ],
//   ["Belgrade",44.786568,20.4489216,2,1  ],
//   ["Bengaluru",12.9715987,77.5945627,2,1  ],
//   ["Berlin",52.5200066,13.404954,3,1  ],
//   ["Bishkek",42.8746212,74.5697617,2,1  ],
//   ["Bogota",4.7109886,-74.072092,2,1  ],
//   ["Brussels",50.8503463,4.3517211,3,3  ],
//   ["Bucharest",44.4267674,26.1025384,2,1  ],
//   ["Budapest",47.497912,19.040235,3,1  ],
//   ["Buenos Aires",-34.6036844,-58.3815591,2,1  ],
//   ["Cairo",30.0444196,31.2357116,1,1  ],
//   ["Cali",3.4516467,-76.5319854,2,1  ],
//   ["Cape Town",-33.9248685,18.4240553,3,1  ],
//   ["Caracas",10.4805937,-66.9036063,2,1  ],
//   ["Chicago",41.8781136,-87.6297982,3,1  ],
//   ["Chisinau",47.0104529,28.8638102,2,1  ],
//   ["Cochabamba",-17.4139766,-66.1653224,2,1  ],
//   ["Cologne",50.937531,6.9602786,3,1  ],
//   ["Colombo",6.9270786,79.861243,2,1  ],
//   ["Copenhagen",55.6760968,12.5683372,3,1  ],
//   ["Cordoba",37.8881751,-4.7793835,2,3  ],
//   ["Dakar",14.716677,-17.4676861,2,1  ],
//   ["Damascus",33.5138073,36.2765279,2,1  ],
//   ["Denver",39.7392358,-104.990251,3,1  ],
//   ["Dhaka",23.810332,90.4125181,1,1  ],
//   ["Doha",25.2854473,51.5310398,1,1  ],
//   ["Dubai",25.2048493,55.2707828,1,1  ],
//   ["Dublin",53.3498053,-6.2603097,3,1  ],
//   ["Dushanbe",38.5597722,68.7870384,2,1  ],
//   ["Geneva",46.2043907,6.1431577,3,1  ],
//   ["Georgetown",6.799958,-58.154937,3,1  ],
//   ["Gothenburg",57.70887,11.97456,3,1  ],
//   ["Guatemala City",14.6349149,-90.5068824,2,1  ],
//   ["Hamburg",53.5510846,9.9936819,3,1  ],
//   ["Hanoi",21.0277644,105.8341598,1,1  ],
//   ["Ho Chi Minh City",10.8230989,106.6296638,1,1  ],
//   ["Houston",29.7604267,-95.3698028,3,1  ],
//   ["Indianapolis",39.768403,-86.158068,3,1  ],
//   ["Istanbul",41.0082376,28.9783589,2,1  ],
//   ["Izmir",38.423734,27.142826,2,1  ],
//   ["Jakarta",-6.17511,106.8650395,2,1  ],
//   ["Jeddah",21.2854067,39.2375507,1,1  ],
//   ["Jerusalem",31.768319,35.21371,2,1  ],
//   ["Karachi",25.0700428,67.2847875,2,1  ],
//   ["Kathmandu",27.7172453,85.3239605,2,1  ],
//   ["Kharkiv",49.9935,36.230383,2,1  ],
//   ["Kiev",50.4501,30.5234,2,1  ],
//   ["Krakow",50.0646501,19.9449799,3,1  ],
//   ["Kuala Lumpur",3.139003,101.686855,2,1  ],
//   ["Lahore",31.5203696,74.3587473,2,1  ],
//   ["Lima",-12.0463731,-77.042754,2,1  ],
//   ["Lisbon",38.7222524,-9.1393366,2,1  ],
//   ["Liverpool",53.4083714,-2.9915726,3,1  ],
//   ["London",51.5073509,-0.1277583,3,1  ],
//   ["Lyon",45.764043,4.835659,3,3  ],
//   ["Madrid",40.4167754,-3.7037902,4,1  ],
//   ["Managua",12.1149926,-86.2361744,2,1  ],
//   ["Marseille",43.296482,5.36978,3,3  ],
//   ["Medan",3.5951956,98.6722227,2,1  ],
//   ["Medellin",6.244203,-75.5812119,2,1  ],
//   ["Melbourne",-37.8136276,144.9630576,3,1  ],
//   ["Mexico City",19.4326077,-99.133208,2,1  ],
//   ["Milan",45.4642035,9.189982,4,3  ],
//   ["Minsk",53.9045398,27.5615244,2,1  ],
//   ["Montevideo",-34.9011127,-56.1645314,2,1  ],
//   ["Montreal",45.5016889,-73.567256,3,1  ],
//   ["Moscow",55.755826,37.6172999,2,1  ],
//   ["Mumbai",19.0759837,72.8776559,2,1  ],
//   ["Munich",48.1351253,11.5819805,3,1  ],
//   ["Nairobi",-1.2920659,36.8219462,2,1  ],
//   ["Naples",40.8517746,14.2681244,4,3  ],
//   ["New Delhi",28.6139391,77.2090212,2,1  ],
//   ["Novosibirsk",55.0083526,82.9357327,2,1  ],
//   ["Odessa",46.482526,30.7233095,2,1  ],
//   ["Oran",35.6970697,-0.6307988,2,1  ],
//   ["Osaka",34.6937378,135.5021651,2,1  ],
//   ["Panama City",8.9823792,-79.5198696,2,1  ],
//   ["Paris",48.856614,2.3522219,3,3  ],
//   ["Philadelphia",39.9525839,-75.1652215,3,1  ],
//   ["Phnom Penh",11.5563738,104.9282099,1,1  ],
//   ["Podgorica",42.4304196,19.2593642,2,2  ],
//   ["Puebla",19.0414398,-98.2062727,2,1  ],
//   ["Quezon City",14.6760413,121.0437003,2,1  ],
//   ["Reykjavik",64.1265206,-21.8174392,3,1  ],
//   ["Rio De Janeiro",-22.9068467,-43.1728965,2,1  ],
//   ["Riyadh",24.7135517,46.6752957,1,1  ],
//   ["Rome",41.9027835,12.4963655,4,3  ],
//   ["Rotterdam",51.9244201,4.4777326,3,1  ],
//   ["Sacramento",38.5815719,-121.4943996,2,1  ],
//   ["Saint Petersburg",59.9342802,30.3350986,2,1  ],
//   ["Salvador",-12.9722184,-38.5014136,2,1  ],
//   ["Sanaa",15.366742,44.191042,2,1  ],
//   ["San Jose",9.9234,-84.089584,3,1  ],
//   ["San Juan",18.4655394,-66.1057355,3,1  ],
//   ["San Salvador",13.6929403,-89.2181911,2,1  ],
//   ["Sao Paulo",-23.5505199,-46.6333094,2,1  ],
//   ["Seoul",37.566535,126.9779692,2,1  ],
//   ["Singapore",1.352083,103.819836,2,1  ],
//   ["Skopje",41.9973462,21.4279956,2,2  ],
//   ["Sofia",42.6977082,23.3218675,2,1  ],
//   ["Stockholm",59.3293235,18.0685808,3,1  ],
//   ["Sydney",-33.8688197,151.2092955,3,1  ],
//   ["Taichung",24.144453,120.673364,2,1  ],
//   ["Tashkent",41.2994958,69.2400734,2,1  ],
//   ["Tbilisi",41.7151377,44.827096,2,1  ],
//   ["Tegucigalpa",14.0722751,-87.192136,2,1  ],
//   ["Tehran",35.6891975,51.3889736,2,1  ],
//   ["Thessaloniki",40.6400629,22.9444191,3,2  ],
//   ["Tokyo",35.6894875,139.6917064,3,1  ],
//   ["Toronto",43.653226,-79.3831843,2,1  ],
//   ["Tunis",36.8064948,10.1815316,2,2  ],
//   ["Valencia",39.4699075,-0.3762881,4,1  ],
//   ["Vienna",48.2081743,16.3738189,3,1  ],
//   ["Vilnius",54.6871555,25.2796514,3,1  ],
//   ["Warsaw",52.2296756,21.0122287,3,1  ],
//   ["Yangon",16.8660694,96.195132,2,1  ],
//   ["Yerevan",40.1791857,44.4991029,2,1  ],
//   ["Yokohama",35.442533,139.637533,2,1  ],
//   ["Zagreb",45.8150108,15.9819189,2,1  ],
//   ["Zurich",47.3768866,8.541694,3,1  ],
//   ["Manhattan",40.781305,-73.9771425,null,null  ]
// ];
var locations = [
  ["Abu Dhabi",24.453884,54.3773438,null,null  ],
  ["Algiers",36.753768,3.0587561,2,1  ],
  ["Almaty",43.2220146,76.8512485,2,1  ],
  ["Amman",31.9453666,35.9283716,2,1  ],
  ["Amsterdam",52.3702157,4.8951679,3,1  ],
  ["Ankara",39.9333635,32.8597419,2,1  ],
  ["Astana",51.1605227,71.4703558,2,1  ],
  ["Asuncion",-25.2637399,-57.575926,2,1  ],
  ["Athens",37.9838096,23.7275388,3,2  ],
  ["Auckland",-36.8484597,174.7633315,3,1  ],
  ["Baghdad",33.3128057,44.3614875,1,1  ],
  ["Baku",40.40718,49.866886,2,1  ],
  ["Bamako",12.6392316,-8.0028892,2,1  ],
  ["Bangkok",13.75423,100.499294,2,1  ],
  ["Barcelona",41.3850639,2.1734035,4,1  ],
  ["Beirut",33.8937913,35.5017767,2,1  ],
  ["Belgrade",44.786568,20.4489216,2,1  ],
  ["Bengaluru",12.9715987,77.5945627,2,1  ],
  ["Berlin",52.5200066,13.404954,3,1  ],
  ["Bishkek",42.8746212,74.5697617,2,1  ],
  ["Bogota",4.7109886,-74.072092,2,1  ],
  ["Brussels",50.8503463,4.3517211,3,3  ],
  ["Bucharest",44.4267674,26.1025384,2,1  ],
  ["Budapest",47.497912,19.040235,3,1  ],
  ["Buenos Aires",-34.6036844,-58.3815591,2,1  ],
  ["Cairo",30.0444196,31.2357116,1,1  ],
  ["Cali",3.4516467,-76.5319854,2,1  ],
  ["Cape Town",-33.9248685,18.4240553,3,1  ],
  ["Caracas",10.4805937,-66.9036063,2,1  ],
  ["Chicago",41.8781136,-87.6297982,3,1  ],
  ["Chisinau",47.0104529,28.8638102,2,1  ],
  ["Cochabamba",-17.4139766,-66.1653224,2,1  ],
  ["Cologne",50.937531,6.9602786,3,1  ],
  ["Colombo",6.9270786,79.861243,2,1  ],
  ["Copenhagen",55.6760968,12.5683372,3,1  ],
  ["Cordoba Esp",37.8881751,-4.7793835,2,3  ],
  ["Dakar",14.716677,-17.4676861,2,1  ],
  ["Damascus",33.5138073,36.2765279,2,1  ],
  ["Denver",39.7392358,-104.990251,3,1  ],
  ["Dhaka",23.810332,90.4125181,1,1  ],
  ["Doha",25.2854473,51.5310398,1,1  ],
  ["Dubai",25.2048493,55.2707828,1,1  ],
  ["Dublin",53.3498053,-6.2603097,3,1  ],
  ["Dushanbe",38.5597722,68.7870384,2,1  ],
  ["Geneva",46.2043907,6.1431577,3,1  ],
  ["Georgetown",6.799958,-58.154937,3,1  ],
  ["Gothenburg",57.70887,11.97456,3,1  ],
  ["Guatemala City",14.6349149,-90.5068824,2,1  ],
  ["Hamburg",53.5510846,9.9936819,3,1  ],
  ["Hanoi",21.0277644,105.8341598,1,1  ],
  ["Ho Chi Minh City",10.8230989,106.6296638,1,1  ],
  ["Houston",29.7604267,-95.3698028,3,1  ],
  ["Indianapolis",39.768403,-86.158068,3,1  ],
  ["Istanbul",41.0082376,28.9783589,2,1  ],
  ["Izmir",38.423734,27.142826,2,1  ],
  ["Jakarta",-6.17511,106.8650395,2,1  ],
  ["Jeddah",21.2854067,39.2375507,1,1  ],
  ["Jerusalem",31.768319,35.21371,2,1  ],
  ["Karachi",25.0700428,67.2847875,2,1  ],
  ["Kathmandu",27.7172453,85.3239605,2,1  ],
  ["Kharkiv",49.9935,36.230383,2,1  ],
  ["Kiev",50.4501,30.5234,2,1  ],
  ["Krakow",50.0646501,19.9449799,3,1  ],
  ["Kuala Lumpur",3.139003,101.686855,2,1  ],
  ["Lahore",31.5203696,74.3587473,2,1  ],
  ["Lima",-12.0463731,-77.042754,2,1  ],
  ["Lisbon",38.7222524,-9.1393366,2,1  ],
  ["Liverpool",53.4083714,-2.9915726,3,1  ],
  ["London",51.5073509,-0.1277583,3,1  ],
  ["Lyon",45.764043,4.835659,3,3  ],
  ["Madrid",40.4167754,-3.7037902,4,1  ],
  ["Managua",12.1149926,-86.2361744,2,1  ],
  ["Marseille",43.296482,5.36978,3,3  ],
  ["Medan",3.5951956,98.6722227,2,1  ],
  ["Medellin",6.244203,-75.5812119,2,1  ],
  ["Melbourne",-37.8136276,144.9630576,3,1  ],
  ["Mexico City",19.4326077,-99.133208,2,1  ],
  ["Milan",45.4642035,9.189982,4,3  ],
  ["Minsk",53.9045398,27.5615244,2,1  ],
  ["Montevideo",-34.9011127,-56.1645314,2,1  ],
  ["Montreal",45.5016889,-73.567256,3,1  ],
  ["Moscow",55.755826,37.6172999,2,1  ],
  ["Mumbai",19.0759837,72.8776559,2,1  ],
  ["Munich",48.1351253,11.5819805,3,1  ],
  ["Nairobi",-1.2920659,36.8219462,2,1  ],
  ["Naples",40.8517746,14.2681244,4,3  ],
  ["New Delhi",28.6139391,77.2090212,2,1  ],
  ["Novosibirsk",55.0083526,82.9357327,2,1  ],
  ["Odessa",46.482526,30.7233095,2,1  ],
  ["Oran",35.6970697,-0.6307988,2,1  ],
  ["Osaka",34.6937378,135.5021651,2,1  ],
  ["Panama City",8.9823792,-79.5198696,2,1  ],
  ["Paris",48.856614,2.3522219,3,3  ],
  ["Philadelphia",39.9525839,-75.1652215,3,1  ],
  ["Phnom Penh",11.5563738,104.9282099,1,1  ],
  ["Podgorica",42.4304196,19.2593642,2,2  ],
  ["Puebla",19.0414398,-98.2062727,2,1  ],
  ["Quezon City",14.6760413,121.0437003,2,1  ],
  ["Reykjavik",64.1265206,-21.8174392,3,1  ],
  ["Rio De Janeiro",-22.9068467,-43.1728965,2,1  ],
  ["Riyadh",24.7135517,46.6752957,1,1  ],
  ["Rome",41.9027835,12.4963655,4,3  ],
  ["Rotterdam",51.9244201,4.4777326,3,1  ],
  ["Sacramento",38.5815719,-121.4943996,2,1  ],
  ["Saint Petersburg",59.9342802,30.3350986,2,1  ],
  ["Salvador",-12.9722184,-38.5014136,2,1  ],
  ["Sanaa",15.366742,44.191042,2,1  ],
  ["San Jose",9.9234,-84.089584,3,1  ],
  ["San Juan",18.4655394,-66.1057355,3,1  ],
  ["San Salvador",13.6929403,-89.2181911,2,1  ],
  ["Sao Paulo",-23.5505199,-46.6333094,2,1  ],
  ["Seoul",37.566535,126.9779692,2,1  ],
  ["Singapore",1.352083,103.819836,2,1  ],
  ["Skopje",41.9973462,21.4279956,2,2  ],
  ["Sofia",42.6977082,23.3218675,2,1  ],
  ["Stockholm",59.3293235,18.0685808,3,1  ],
  ["Sydney",-33.8688197,151.2092955,3,1  ],
  ["Taichung",24.144453,120.673364,2,1  ],
  ["Tashkent",41.2994958,69.2400734,2,1  ],
  ["Tbilisi",41.7151377,44.827096,2,1  ],
  ["Tegucigalpa",14.0722751,-87.192136,2,1  ],
  ["Tehran",35.6891975,51.3889736,2,1  ],
  ["Thessaloniki",40.6400629,22.9444191,3,2  ],
  ["Tokyo",35.6894875,139.6917064,3,1  ],
  ["Toronto",43.653226,-79.3831843,2,1  ],
  ["Tunis",36.8064948,10.1815316,2,2  ],
  ["Valencia",39.4699075,-0.3762881,4,1  ],
  ["Vienna",48.2081743,16.3738189,3,1  ],
  ["Vilnius",54.6871555,25.2796514,3,1  ],
  ["Warsaw",52.2296756,21.0122287,3,1  ],
  ["Yangon",16.8660694,96.195132,2,1  ],
  ["Yerevan",40.1791857,44.4991029,2,1  ],
  ["Yokohama",35.442533,139.637533,2,1  ],
  ["Zagreb",45.8150108,15.9819189,2,1  ],
  ["Zurich",47.3768866,8.541694,3,1  ],
  ["Manhattan",40.781305,-73.9771425,null,null  ],
  ["Lagos",6.518886,3.370302,null,null  ],
  ["Brasilia",-15.800428,-47.883015,null,null  ],
  ["Manaus",-3.114877,-60.014958,null,null  ],
  ["Santiago",-33.463485,-70.647698,null,null  ],
  ["Cordoba Arg",-31.419291,-64.189169,null,null  ],
  ["Calgary",51.043035,-114.070479,null,null  ],
  ["Edmonton",53.542746,-113.494219,null,null  ],
  ["Kinshasa",-4.437858,15.26613,null,null  ],
  ["Pointe-Noire",-4.769874,11.865715,null,null  ],
  ["Dar es Salaam",-6.795511,39.21113,null,null  ],
  ["Mombasa",-4.044594,39.667926,null,null  ],
  ["Lusaka",-15.390373,28.322917,null,null  ],
  ["Harare",-17.826805,31.034069,null,null  ],
  ["Khartoum",15.511506,32.557585,null,null  ],
  ["Yaounde",3.850854,11.504273,null,null  ],
  ["Luanda",-8.820741,13.230458,null,null  ],
  ["Windhoek",-22.563431,17.065831,null,null  ],
  ["Gaborone",-24.623325,25.921928,null,null  ],
  ["Johannesburg",-26.201029,28.045177,null,null  ],
  ["Maputo",-25.966919,32.574091,null,null  ],
  ["Bujumbura",-3.362491,29.359919,null,null  ],
  ["Tripoli",32.888854,13.191615,null,null  ],
  ["Muscat",23.593738,58.406846,null,null  ],
  ["Addis Ababa",8.983048,38.758443,null,null  ],
  ["Kampala",0.346359,32.582421,null,null  ],
  ["Abuja",9.071323,7.397867,null,null  ],
  ["Douala",4.049324,9.767785,null,null  ],
  ["Swakopmund",-22.645604,14.600413,null,null  ],
  ["Bulawayo",-20.125479,28.624305,null,null  ],
  ["Port Elizabeth",-33.95198,25.592369,null,null  ],
  ["Abidjan",5.36865,-4.007421,null,null  ],
  ["Accra",5.607943,-0.186604,null,null  ],
  ["Libreville",0.420823,9.465533,null,null  ],
  ["Conakry",9.646735,-13.580015,null,null  ],
  ["Medina",24.528989,39.569396,null,null  ],
  ["Shiraz",29.60279,52.583902,null,null  ],
  ["Kabul",34.570502,69.207375,null,null  ],
  ["Ulaanbaatar",47.892986,106.907023,null,null  ],
  ["Gaziantep",37.068351,37.377909,null,null  ],
  ["Santa Cruz de la Sierra",-17.804911,-63.157219,null,null  ],
  ["Rosario",-32.951142,-60.69361,null,null  ],
  ["Salta",-24.779414,-65.423668,null,null  ],
  ["La Paz",-16.487636,-68.119253,null,null  ],
  ["Quito",-78.464875,-0.172174,null,null  ],
  ["Guayaquil",-2.165689,-79.923439,null,null  ],
  ["Cusco",-13.52985,-71.967745,null,null  ],
  ["Bordeaux",44.839113,-0.579593,null,null  ],
  ["Poznan",52.410008,16.925048,null,null  ],
  ["Riga",56.953428,24.103161,null,null  ],
  ["Graz",47.071589,15.43957,null,null  ],
  ["Hyderabad",17.396387,78.486259,null,null  ],
  ["Turin",45.071255,7.686803,null,null  ],
  ["Rouen",49.4437,1.099773,null,null  ],
  ["Rabat",33.973541,-6.8498,null,null  ],
  ["Casablanca",33.576089,-7.589716,null,null  ],
  ["Frankfurt",50.114528,8.683587,null,null  ],
  ["Adana",36.966221,35.3454412,null,null  ],
  ["Konya",37.869734,32.493753,null,null  ],
  ["Kolkata",22.577117,88.364548,null,null  ],
  ["Chennai",13.085909,80.269738,null,null  ],
  ["Bangalore",12.976372,77.594776,null,null  ]
];

var selectedCount = 0;
var selectedList = [];
var remove = false;
var group1 = L.featureGroup();
//Calling set point colors for first setup here
setPointColors();
// setDefaultSelection();

</script>

<!--d3 chart1-->
<script>
var margin = {top: 20, right: 30, bottom: 30, left: 50},
    width = document.getElementById("generalDiv").offsetWidth - margin.left - margin.right,
    height = 150 - margin.top - margin.bottom;

var parseDate = d3.time.format("%Y%m%d").parse;

var xArray = ['Mon', 'Tue', 'Wed', 'Thur', 'Fri', 'Sat', 'Sun'];

var x2 = d3.scale.ordinal()
    .domain(xArray)
    .range([14/168 * width, 38/168 * width, 62/168 * width, 86/168 * width, 110/168 * width, 134/168 * width, 158/168 * width]);
    
var xAxis2 = d3.svg.axis()
      .scale(x2)
      .orient("bottom")
      .ticks(7);
      
xAxis2.tickSize(0);


var x = d3.scale.linear()
    .domain([0, 168])
    .range([0, width]);

var y = d3.scale.linear()
    .range([height, 0]);

var color = d3.scale.category10();

var xAxis = d3.svg.axis()
    .scale(x)
    .orient("bottom");

var yAxis = d3.svg.axis()
    .scale(y)
    .ticks(0)
    .orient("left");

var line = d3.svg.line()
    .x(function(d) { return x(d.date); })
    .y(function(d) { return y(d.temperature); });

var svg1 = d3.select("#chart1").append("svg")
    .attr("width", width + margin.left + margin.right)
    .attr("height", height + margin.top + margin.bottom)
  .append("g")
    .attr("transform", "translate(" + margin.left + "," + margin.top + ")");

d3.csv("general2.csv", function(error, data) {
  color.domain(d3.keys(data[0]).filter(function(key) { return key !== "date"; }));

var cities = color.domain().map(function(name) {
return {
  name: name,
  values: data.map(function(d) {
    return {date: d.date, temperature: +d[name]};
  })
};
});


y.domain([
d3.min(cities, function(c) { return d3.min(c.values, function(v) { return v.temperature; }); }),
d3.max(cities, function(c) { return d3.max(c.values, function(v) { return v.temperature; }); })
]);

svg1.append("g")
  .attr("class", "hidden")
  .attr("transform", "translate(0," + height + ")")
  .call(xAxis);
  
svg1.append("g")
  .attr("class", "x axis")
  .attr("transform", "translate(0," + height + ")")
  .call(xAxis2);

svg1.append("g")
  .attr("class", "y axis")
  .attr("class", "hidden")
  .call(yAxis)
  .selectAll("text").remove();
    
svg1.append("text")
    .attr("transform", "rotate(-90)")
    .attr("y", 0-margin.left)
    .attr("x",0 - (height / 2))
    .attr("dy", "2em")
    .style("text-anchor", "middle")
    .style("font-size", "16px") 
    .style('fill', '#3a3a3a')
    .style('font-family', 'Open Sans')
    .text("General");

var city = svg1.selectAll(".city")
  .data(cities)
.enter().append("g")
  .attr("class", "city");

city.append("path")
  .attr("class", "line")
  .attr("d", function(d) { return line(d.values); })
  .attr("id", function(d) { return (d.name.replace(/ /g,'')) + "GeneralLine"; })
  .attr("active", false)
  .style("opacity", 0)
  .style("stroke", function(d) { return color(d.name); });

});
</script>


<!--d3 chart2-->
<script>
var margin = {top: 20, right: 30, bottom: 30, left: 50},
    width = document.getElementById("generalDiv").offsetWidth - margin.left - margin.right,
    height = 150 - margin.top - margin.bottom;

var parseDate = d3.time.format("%Y%m%d").parse;

var xArray = ['Mon', 'Tue', 'Wed', 'Thur', 'Fri', 'Sat', 'Sun'];

var x2 = d3.scale.ordinal()
    .domain(xArray)
    .range([14/168 * width, 38/168 * width, 62/168 * width, 86/168 * width, 110/168 * width, 134/168 * width, 158/168 * width]);
    
var xAxis2 = d3.svg.axis()
      .scale(x2)
      .orient("bottom")
      .ticks(7);
      
xAxis2.tickSize(0);

var y = d3.scale.linear()
    .range([height, 0]);

var color = d3.scale.category10();

var yAxis = d3.svg.axis()
    .scale(y)
    .ticks(0)
    .orient("left");

var line = d3.svg.line()
    .x(function(d) { return x(d.date); })
    .y(function(d) { return y(d.temperature); });

var svg2 = d3.select("#chart2").append("svg")
    .attr("width", width + margin.left + margin.right)
    .attr("height", height + margin.top + margin.bottom)
  .append("g")
    .attr("transform", "translate(" + margin.left + "," + margin.top + ")");

d3.csv("restaurant2.csv", function(error, data) {
  color.domain(d3.keys(data[0]).filter(function(key) { return key !== "date"; }));

var cities = color.domain().map(function(name) {
return {
  name: name,
  values: data.map(function(d) {
    return {date: d.date, temperature: +d[name]};
  })
};
});

y.domain([
d3.min(cities, function(c) { return d3.min(c.values, function(v) { return v.temperature; }); }),
d3.max(cities, function(c) { return d3.max(c.values, function(v) { return v.temperature; }); })
]);

svg2.append("g")
  .attr("class", "x axis")
  .attr("transform", "translate(0," + height + ")")
  .call(xAxis2);

svg2.append("g")
  .attr("class", "y axis")
  .attr("class", "hidden")
  .call(yAxis)
  .selectAll("text").remove();

svg2.append("text")
    .attr("transform", "rotate(-90)")
    .attr("y", 0-margin.left)
    .attr("x",0 - (height / 2))
    .attr("dy", "2em")
    .style("text-anchor", "middle")
    .style("font-size", "16px") 
    .style('fill', '#3a3a3a')
    .style('font-family', 'Open Sans')
    .text("Restaurant");

var city = svg2.selectAll(".city")
  .data(cities)
.enter().append("g")
  .attr("class", "city");

city.append("path")
  .attr("class", "line")
  .attr("d", function(d) { return line(d.values); })
  .attr("id", function(d) { return (d.name.replace(/ /g,'')) + "RestaurantLine"; })
  .attr("active", false)
  .style("opacity", 0)
  .style("stroke", function(d) { return color(d.name); });

});
</script>


<!--d3 chart3-->
<script>
var margin = {top: 20, right: 30, bottom: 30, left: 50},
    width = document.getElementById("generalDiv").offsetWidth - margin.left - margin.right,
    height = 150 - margin.top - margin.bottom;

var parseDate = d3.time.format("%Y%m%d").parse;

var xArray = ['Mon', 'Tue', 'Wed', 'Thur', 'Fri', 'Sat', 'Sun'];

var x2 = d3.scale.ordinal()
    .domain(xArray)
    .range([14/168 * width, 38/168 * width, 62/168 * width, 86/168 * width, 110/168 * width, 134/168 * width, 158/168 * width]);
    
var xAxis2 = d3.svg.axis()
      .scale(x2)
      .orient("bottom")
      .ticks(7);

xAxis2.tickSize(0);

var y = d3.scale.linear()
    .range([height, 0]);

var color = d3.scale.category10();

var yAxis = d3.svg.axis()
    .scale(y)
    .ticks(0)
    .orient("left");

var line = d3.svg.line()
    .x(function(d) { return x(d.date); })
    .y(function(d) { return y(d.temperature); });

var svg3 = d3.select("#chart3").append("svg")
    .attr("width", width + margin.left + margin.right)
    .attr("height", height + margin.top + margin.bottom)
  .append("g")
    .attr("transform", "translate(" + margin.left + "," + margin.top + ")");

d3.csv("retail2.csv", function(error, data) {
  color.domain(d3.keys(data[0]).filter(function(key) { return key !== "date"; }));

var cities = color.domain().map(function(name) {
return {
  name: name,
  values: data.map(function(d) {
    return {date: d.date, temperature: +d[name]};
  })
};
});

y.domain([
d3.min(cities, function(c) { return d3.min(c.values, function(v) { return v.temperature; }); }),
d3.max(cities, function(c) { return d3.max(c.values, function(v) { return v.temperature; }); })
]);

svg3.append("g")
  .attr("class", "x axis")
  .attr("transform", "translate(0," + height + ")")
  .call(xAxis2);

svg3.append("g")
  .attr("class", "y axis")
  .attr("class", "hidden")
  .call(yAxis)
  .selectAll("text").remove();

svg3.append("text")
    .attr("transform", "rotate(-90)")
    .attr("y", 0-margin.left)
    .attr("x",0 - (height / 2))
    .attr("dy", "2em")
    .style("text-anchor", "middle")
    .style("font-size", "16px") 
    .style('fill', '#3a3a3a')
    .style('font-family', 'Open Sans')
    .text("Retail");

var city = svg3.selectAll(".city")
  .data(cities)
.enter().append("g")
  .attr("class", "city");

city.append("path")
  .attr("class", "line")
  .attr("d", function(d) { return line(d.values); })
  .attr("id", function(d) { return (d.name.replace(/ /g,'')) + "RetailLine"; })
  .attr("active", false)
  .style("opacity", 0)
  .style("stroke", function(d) { return color(d.name); });

});
</script>


<script>
// Get the Sidebar
var mySidebar = document.getElementById("mySidebar");

// Get the DIV with overlay effect
var overlayBg = document.getElementById("myOverlay");

// Toggle between showing and hiding the sidebar, and add overlay effect
function w3_open() {
  if (mySidebar.style.display === 'block') {
    mySidebar.style.display = 'none';
    overlayBg.style.display = "none";
  } else {
    mySidebar.style.display = 'block';
    overlayBg.style.display = "block";
  }
}

// Close the sidebar with the close button
function w3_close() {
  mySidebar.style.display = "none";
  overlayBg.style.display = "none";
}


// $(document).ready(function () {
//   //your code here
// //   $('#body').css('min-height', screen.height);
// //   $('#body').css('max-height', screen.height);
// });


//getting a random city to display when page is opened
function getRandomCity(){
    //hard coded values for the layer number
    //This will need to be adjusted if cities are added or removed
    randomNumber = getRandomInt(45, 180);
    // console.log(randomNumber);
    return group1._layers[randomNumber];
}

//random int inclusive
function getRandomInt(min, max) {
    min = Math.ceil(min);
    max = Math.floor(max);
    return Math.floor(Math.random() * (max - min + 1)) + min;
}

var randomCity = getRandomCity();
var waitCount = 0;

//waiting for the d3 lines to all be drawn before selecting the first default one
//async and await wasn't working but may need to be investigated further
function waitForLines(){
    if(waitCount < 20){
        waitCount++;
        // console.log("checking variable...");
        // console.log(randomCity);
        if(randomCity !== undefined){
            var lineName = randomCity.options.title;
            lineName = "#" + lineName.replace(/ /g,'');
            var initialGeneralLine = d3.select(lineName + "GeneralLine");
            var initialRetailLine = d3.select(lineName + "RetailLine");
            var initialRestaurantLine = d3.select(lineName + "RestaurantLine");
            
            if(initialGeneralLine[0][0] !== null && initialRetailLine[0][0] !== null && initialRestaurantLine[0][0] !== null){
                //variable exists, do what you want
                // console.log("Variable loaded");
                setDefaultSelection();
            }
            else{
                setTimeout(waitForLines, 250);
            }
        }
        else{
            setTimeout(waitForLines, 250);
        }
    }
}

waitForLines();

</script>

</body>
</html>